<!.IfNotDefined=ISFirefox>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/htm14/strict.dtd">
<!.EndIf>
<html lang="<!.StringMappings=LANG_CODE>">
<head>
<title><!.UnformattedStringMappings=STR_ACUXE_TITLE></title>
<meta http-equiv="Content-Type" content="text/html; charset=<!.StringMappings=LANG_CHARSET>"/>
<script type="text/javascript">
   // Get environment attributes.
   <!.IfNotDefined=ISOffline>
   var g_isOfflineEnvironment = false;
   <!.Else>
   var g_isOfflineEnvironment = true;
   <!.EndIf>
   <!.IfNotDefined=ISShowReboot>
   var g_isOnOfflineCD = false;
   <!.Else>
   var g_isOnOfflineCD = true;
   <!.EndIf>
   // ACU is on SmartStart if it's running in an offline environment with
   // show reboot disabled.
   var g_isOnOfflineSmartStart = g_isOfflineEnvironment && !g_isOnOfflineCD;

   var HEADER_TYPE_TASK = "task";
   var HEADER_TYPE_TASK_LIST = "task_list";
   var HEADER_TYPE_DIAGNOSTICS_TASK_LIST = "diagnostics_task_list";
   var HEADER_TYPE_MINI = "mini";
   var HEADER_TYPE_INFO = "info";
   var x_date           = new Date();
   x_startTime          = x_date.getTime();
   x_jsLoadTime         = 0;
   x_startEvalTime      = 0;
   x_totalEvalTime      = 0;
   x_startRequestTime   = 0;
   x_totalRequestTime   = 0;
</script>
<script type="text/javascript">
systemname="";
username="<!.StringMappings=STR_LOCAL_ADMINISTRATOR>";
localaccess="";
debugurl="";
</script>
<!.IfNotDefined=ISOffline>
<script src="/proxy/smhui/getuiinfo?JS&systemname&username&localaccess&debugurl"></script>
<!.EndIf>
<!.IfNotDefined=NDEBUG>
<!-- BEGIN_MULTIPLE_CSS_INCLUDE -->
<link rel="stylesheet" type="text/css" href="guido.css"/>
<link rel="stylesheet" type="text/css" href="default.css"/>
<link rel="stylesheet" type="text/css" href="blue_theme.css"/>
<link rel="stylesheet" type="text/css" href="diagnose.css"/>
<link rel="stylesheet" type="text/css" href="widgets.css"/>
<link rel="stylesheet" type="text/css" href="wizards.css"/>
<link rel="stylesheet" type="text/css" href="tree.css"/>
<link rel="stylesheet" type="text/css" href="moreinfo.css"/>
<link rel="stylesheet" type="text/css" href="mgmtinfo.css"/>
<link rel="stylesheet" type="text/css" href="dropdown.css"/>
<link rel="stylesheet" type="text/css" href="help.css"/>
<!-- END_MULTIPLE_CSS_INCLUDE -->
<!.Else>
<!-- BEGIN_SINGLE_CSS_INCLUDE -->
<link rel="stylesheet" type="text/css" href="main.css"/>
<!-- END_SINGLE_CSS_INCLUDE -->
<!.EndIf>
<script type="text/javascript">
   if (g_isOnOfflineSmartStart)
   {
      document.write('<link rel="stylesheet" type="text/css" href="smartstart.css"/>');
   }
</script>
</head>

<body id="mainbody" oncontextmenu="return false;">
<div style="width:100%;" id="LoadingAreaID" class="LoadingArea"><span><!.UnformattedStringMappings=STR_LOADING></span><br/><img src="images/progress_bar_large.gif"/ alt="<!.UnformattedStringMappings=STR_LOADING>"/></div>
<!-- Header Area -->
<script type="text/javascript">
   var sHeaderIconLeftHTML;
   var sHeaderIconRightHTML;
   var sHeaderUsernameHTML;
   var sHeaderPhotoHTML;
   if(g_isOnOfflineSmartStart)
   {
      sHeaderIconLeftHTML = '';
      sHeaderIconRightHTML = '<td class="mastheadIcon"><img src="images/HP_S_W_RGB_50_SM.gif" width="50" alt="HP"/></td>';
      sHeaderPhotoHTML = '';
   }
   else
   {
      sHeaderIconLeftHTML = '<td class="mastheadIcon"><img src="images/HP_S_W_RGB_150_MN_30.gif" width="30" alt="HP"/></td>';
      sHeaderIconRightHTML = '';
      sHeaderPhotoHTML = '<td class="mastheadPhoto"><img id="APP_LOGO_ID" src="images/app_logo_1_215x40.jpg" alt="HP"/></td>';
   }
   if(g_isOfflineEnvironment)
   {
      sHeaderUsernameHTML = '';
   }
   else
   {
      sHeaderUsernameHTML = '<!.UnformattedStringMappings=STR_USER>: ' + username + '<br/>';
   }
   var sAppHeaderHTML = '<div class="appHeaderDiv"><table id="ApplicationHeader" class="applicationMastheadSmall" border="0" cellpadding="0" cellspacing="0">';
   sAppHeaderHTML += '<tr>' + sHeaderIconLeftHTML;
   sAppHeaderHTML += '<td class="mastheadTitle"><!.UnformattedStringMappings=STR_ACUXE_TITLE></td>';
   sAppHeaderHTML += sHeaderPhotoHTML;
   sAppHeaderHTML += '<td class="mastheadLinks" lang="en">';
   sAppHeaderHTML += sHeaderUsernameHTML;
   sAppHeaderHTML += '<!.UnformattedStringMappings=STR_VERSION>: <!.StringMappings=STR_ACUXE_VERSION>';
   <!.IfNotDefined=NDEBUG>
   sAppHeaderHTML += '&nbsp;&nbsp;<i>Debug</i>';
   <!.EndIf>
   sAppHeaderHTML += '</td>';
   sAppHeaderHTML += sHeaderIconRightHTML + '</tr></table></div>';
   document.write(sAppHeaderHTML);
</script>
<!-- include scriptfiles after loading graphic so the graphic will be shown on the screen while loading scripts -->
<script src="strings.js"></script>

<!.IfNotDefined=NDEBUG>
<!-- START_MULTIPLE_JS_INCLUDE -->
<script src="buttonManager.js"></script>
<script src="global.js"></script>
<script src="storage_pres.js"></script>
<script src="str_maps.js"></script>
<script src="default.js"></script>
<script src="ImageDropDown.js"></script>
<script src="debug.js"></script>
<script src="requestor.js"></script>
<script src="stormod.js"></script>
<script src="cmd_status.js"></script>
<script src="data.js"></script>
<script src="event_model_ie.js"></script>
<script src="event_model_m.js"></script>
<script src="event_model.js"></script>
<script src="update_manager.js"></script>
<script src="menu.js"></script>
<script src="tree.js"></script>
<script src="device_view.js"></script>
<script src="view_fac.js"></script>
<script src="widgets_core.js"></script>
<script src="widgets_ext.js"></script>
<script src="widgets_wiz.js"></script>
<script src="builder_widget.js"></script>
<script src="dlg.js"></script>
<script src="dlg_generic.js"></script>
<script src="dlg_configure.js"></script>
<script src="dlg_tasks.js"></script>
<script src="dlg_fac.js"></script>
<script src="dlg_moreinfo.js"></script>
<script src="dlg_cacheinfo.js"></script>
<script src="dlg_status.js"></script>
<script src="dlg_eventlog.js"></script>
<script src="dlg_tab.js"></script>
<script src="dlg_wizards.js"></script>
<script src="dlg_op.js"></script>
<script src="wbrd.js"></script>
<script src="wbrd_treeview.js"></script>
<script src="wbrd_status.js"></script>
<script src="wbrd_config.js"></script>
<script src="wbrd_diagnose.js"></script>
<script src="wbrd_wiz.js"></script>
<script src="wiz_man.js"></script>
<script src="wiz_pages.js"></script>
<script src="widgets_diag.js"></script>
<script src="dlg_diags.js"></script>
<script src="nav_man.js"></script>
<script src="common.js"></script>
<script src="drive_selector.js"></script>
<script src="slider.js"></script>
<script src="ssd.js"></script>
<!-- END_MULTIPLE_JS_INCLUDE -->
<!.Else>
<!-- START_SINGLE_JS_INCLUDE -->
<script type="text/javascript" src="main.js"></script>
<!-- END_SINGLE_JS_INCLUDE -->
<!.EndIf>

<script type="text/javascript">
var g_bTaskModified = false;
var g_userSessionKey = "";
var g_lockState = "OK";
var g_sp = new CStoragePresenter();   // CStoragePresenter - global for performance
CResizeCtrl.setupGlobalResize();
window.onresize = CResizeCtrl.handleResize;
window.focus();
var g_dropDown = null;
var g_DocumentHKManager = null;
var g_popupWindows = new Array();     // Array containing references to popup windows
</script>

<!-- ---------------------- START DIV CONTAINER TBM Area ----------------------- -->
<div id="TBMContainerArea">
<div id="TBMArea" class="TBMArea hidden">
<div id="TAB_AREA_ID">
<div style="height:22px;margin-top:6px;">
<div id="tabSet" class="tabSet">
<div id="configure" class="tabOff"><a href="#"><!.UnformattedStringMappings=STR_CONFIGURATION></a></div>
<div id="ssp" class="tabOff" hidden><a href="#"><!.UnformattedStringMappings=STR_SSP></a></div>
<div id="diagnose" class="tabOff"><a href="#"><!.UnformattedStringMappings=STR_DIAGNOSTICS></a></div>
<div id="lock" class="tabOff hidden"><a href="#">lock</a></div>
<div id="fail" class="tabOff hidden"><a href="#">fail</a></div>
<div id="wizards" class="tabOff"><a href="#"><!.UnformattedStringMappings=STR_WIZARDS></a></div>
<div id="helpLinkArea"></div>
</div>
</div>
</div>
<div style="background-color:#CCCCCC;font-size:0px;height:5px;"></div>
<div style="background-color:#CCCCCC;height:30px;" id="TAB_CONTENT_ID"></div>
<div style="background-color:#FFFFFF;font-size:0px;height:3px;"></div> 
<div id="GeneralApplicationAreaID" class="hidden">
<div style="position:absolute;width:100%;height:100%;z-index:3;" id="SPLITTER_CONTAINER">
<div style="cursor:col-resize;position:absolute;width:7px;top:0px;height:100%;z-index:4;" id="SPLITTER_BAR"></div>
<div class="GlobalStatusView hidden" id="STATUS_AREA_ID"></div>
<div class="GlobalTreeView hidden" id="TREE_VIEW_ID"></div>
<div class="InnerGeneralAppArea hidden" id="PASSWORD_APP_AREA_ID"></div>
<div class="InnerGeneralAppArea hidden" id="CONFIG_APP_AREA_ID"></div>
<div class="InnerGeneralAppArea hidden" id="SSP_APP_AREA_ID"></div>
<div class="InnerGeneralAppArea hidden" id="MANAGE_APP_AREA_ID"></div>
<div class="InnerGeneralAppArea hidden" id="DIAGS_APP_AREA_ID"></div>
<div class="InnerGeneralAppArea hidden" id="LOCK_APP_AREA_ID"></div>
<div class="InnerGeneralAppArea hidden" id="FAIL_APP_AREA_ID"></div>
<div class="InnerGeneralAppArea hidden" id="WIZARDS_APP_AREA_ID"></div>
</div>
<div class="GlobalControlSelect" id="CONTROL_SELECT_ID"></div>
</div>   
</div>
</div>
<!-- Footer Area -->
<div id="ApplicationFooter" style="height:35px;">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
   <td>
   <div style="font-size:0pt;width:5px;height:35px;background:white;"></div>
   </td>
   <td id="ApplicationFooterFirst">
   <div style="position: absolute; left: 8px; margin-top:-9px" class="buttonsAreExitNewLeftAligned" >
      <div class="bWrapperUp bEmphasized">
         <div>
            <div>
            <!.IfNotDefined=ISShowReboot>
               <button class="hpButton" id="exitButton" style="width:auto;" onclick="CloseApp()"><!.UnformattedStringMappings=STR_EXIT_ACU></button>
            <!.Else>
               <button class="hpButton" id="exitButton" style="width:auto;" onclick="CloseApp()"><!.UnformattedStringMappings=STR_REBOOT_ON_EXIT_ACU></button>
            <!.EndIf>
            </div>
         </div>
      </div>     
   </div>
   <div class="clearFloats"></div>
   </td>
   <td id="ApplicationFooterSecond">
   <div class="buttonsAreRightAligned">
      <div id="lockGlobalButtons" style="display:none;">
         <div class="bWrapperUp"><div><div><button class="hpButton" style="width:auto;" id="retryButton" onclick="RetryLock();"><!.UnformattedStringMappings=STR_LOCK_RETRY></button></div></div></div>
         <div class="bWrapperUp"><div><div><button class="hpButton" style="width:auto;" id="overrideButton" onclick="OverrideLock();"><!.UnformattedStringMappings=STR_LOCK_OVERRIDE></button></div></div></div>
      </div>
      <div id="tabButtons">
      </div>
   </div>
   <div class="clearFloats"></div>
   </td>
   <td>
   <div style="font-size:0px;width:5px;height:35px;background:white;"></div>
   </td>
</tr>
</table>
</div>
<script type="text/javascript">
window.onload = function()
{
};

// This code sets up what SMU is to do when the app is closed. It catches both 
// the "Exit ACU" button and also when they click the close window icon of the 
// browser itself. 
// Note: changed from onbeforeunload since Mozilla 1.6 and earlier do not support it
window.onunload = function()
{ 
   // Turn off all the LED's
   if (g_dropDown && g_lockState == "OK")
   {
      // Get the currently selected controller unique id   
      try { g_blinkManager.stopBlink(); } catch(e) {}
   }
   // Set tab back to default
   (new CUserPreferences).SetValue("TAB_ID", g_sp.LS(STR_CONFIGURE));
   // Run the user session exit function
   try { executeUserSessionExitRequest(); } catch(e) {}
   // Close help and printer friendly popup windows that are still open
   for (var i=0; i<g_popupWindows.length; ++i)
   {
      if(g_popupWindows[i].closed == false)
      {
         g_popupWindows[i].close();
      }
   }
   CleanUp();
};


CResizeCtrl.spot1();

// Global variables. Grouping them here to keep things organized.
var g_blinkManager = new CBlinkManager();
var g_model;
var g_tabManager;       // CTabDlg
var g_treeView;         // CTreeViewWB. This is global for performance reasons.
var g_statusView;
var g_lockView;         // CLockDlg
var g_failView;         // CFailDlg
var g_AppAreaHKManager;

//These global objects have to be instantiated in the following order
//for dependency reasons.
g_model = new StorageModel();

function CleanUp()
{
   // Call destructors
   if (g_tabManager) g_tabManager.Destructor();     
   if (g_DocumentHKManager) g_DocumentHKManager.Destructor();
   if (g_treeView) g_treeView.Destructor();
   
   if (g_statusView) g_statusView.Destructor();
      
   // Remove global references to JS objects
   g_blinkManager = null;
   g_model = null;
   g_tabManager = null;
   g_treeView = null;
   g_statusView = null;
   g_popupWindows = null;
   delete g_blinkManager;
   delete g_model;
   delete g_tabManager;
   delete g_treeView;
   delete g_statusView;  
   delete g_popupWindows;
   
   // Delete Splitter bars
   CSplitterBar.Destructor();
      
   // Force garbage collection in IE
   if (window.CollectGarbage) 
   {
      CollectGarbage();
   }      
}

// Rescan - Basically restarts the app. Even if a cookie is set, we will go to the 
//          initial welcome screen so that the user knows something happened. 
function Rescan()
{
   var rescan = false;
   var session = new CSessionData();

   if (session.GetData("task_state", "task_in_progress"))
   {
      if (confirm(g_sp.LS(STR_MSG_RESCAN_IN_TASK)))
      {
         rescan = true;
         session.SetData("task_state", "task_in_progress", false);
      }
   }
   else if (session.GetData("wizard_state", "wizard_in_progress"))
   {
      if (confirm(g_sp.LS(STR_MSG_RESCAN_IN_WIZARD)))
      {
         rescan = true;
         session.SetData("wizard_state", "wizard_in_progress", false);
      }
   }
   else
   {
      if (!g_dropDown.getNumberofChildren() || confirm(g_sp.LS(STR_MSG_RESCAN_WARNING)))
      {
         rescan = true;
      }
   }
   if (rescan)
   {
      (new CUserPreferences).SetValue("TAB_ID", g_sp.LS(STR_CONFIGURE));
      g_blinkManager.stopBlink();
      g_lockState = "OK";
      // Setup to reenumerate
      var requestor = new CDeviceRequestor();
      requestor.setAttribute(GUI_NAME_DEPTH, 1);
      requestor.setAttribute(GUI_NAME_REENUMERATE, GUI_VALUE_FALSE);
      requestor.setAttribute(GUI_NAME_RESCAN, GUI_VALUE_TRUE);
      requestor.setAttribute(GUI_NAME_INCLUDE_OPERATIONS, GUI_VALUE_FALSE);
      modroot = requestor.executeRequest();

      javascript: history.go(0);
   }
}

var g_controllers; // list of controllers
var g_hasSSPControllers = false;
var g_nonSAControllers; // list of non Smart Array controllers
function controllerListCallback(modroot)
{
   // Use a device finder on what we got back to find storage systems and controllers.
   var internalFinder = new DeviceFinder();
   internalFinder.setAttribute(ATTR_NAME_TYPE, ATTR_VALUE_TYPE_ARRAY_CONTROLLER);
   internalFinder.setAttribute(ATTR_NAME_LOCATION, ATTR_VALUE_LOCATION_LOCAL);
   var children = internalFinder.findAll(modroot);
   var externalFinder = new DeviceFinder();
   externalFinder.setAttribute(ATTR_NAME_TYPE, ATTR_VALUE_TYPE_STORAGE_SYSTEM);
   var externalControllers = externalFinder.findAll(modroot);
   children = children.concat(externalControllers);
   var failedFinder = new DeviceFinder();
   failedFinder.setAttribute(ATTR_NAME_TYPE, ATTR_VALUE_TYPE_FAILED_ARRAY_CONTROLLER);
   var failedControllers = failedFinder.findAll(modroot);
   children = children.concat(failedControllers);
   g_controllers = children;
   g_hasSSPControllers = externalControllers.length>0;
   var nonSAFinder = new DeviceFinder();
   nonSAFinder.setAttribute(ATTR_NAME_TYPE, ATTR_VALUE_TYPE_NON_SMARTARRAY_CONTROLLER);
   g_nonSAControllers = nonSAFinder.findAll(modroot);
   modroot.m_children = new Array();
   g_model.DeviceRootIs(modroot);
   ShowApp();
}

// Desc - Returns an array of device that are controllers from the an
//        ACU perspective. 
// Note:
// The children of g_model will be wiped out when this is called, so
// if a controller has been previously selected, its children in g_model
// will be replaced.
function controllerList()
{
   // We will ask for the modroot plus a certain depth. Depth of 1 implies modroot plus
   // controllers/subsystems. 
   var requestor = new CDeviceRequestor();
   requestor.setAttribute(GUI_NAME_DEPTH,1);
   
   // Already reenumerated when we started. Do NOT reenumerate again until they hit rescan. This is for performance reasons.  
   requestor.setAttribute(GUI_NAME_REENUMERATE, GUI_VALUE_FALSE);
   requestor.setAttribute(GUI_NAME_INCLUDE_OPERATIONS, GUI_VALUE_FALSE);
   requestor.executeRequest(controllerListCallback);
}

var oHelpLinkArea = document.getElementById("helpLinkArea");
oHelpLinkArea.innerHTML = "<a href='#' class='HelpButtonLink' onclick=ShowHelp(); >" + filterIcon('images/help20.png', '20px', '20px') + "<span style='margin-left:2px;'>" + g_sp.LS(STR_HELP_LINK) + "</span></a>";

function ShowApp()
{
   // Remove loading image
   var e=document.getElementById("LoadingAreaID");
   if (e) {e.style.display="none";}
   var f=document.getElementById("TBMArea");
   if (f) {f.style.display="block";}

   var oCtrlDropDown = document.getElementById("TAB_CONTENT_ID");
   g_dropDown = new CImageDropDown("g_dropDown");
   g_dropDown.SetCustomHandler(showCurrentSelectedController);

   for(var i=0; i<g_controllers.length; ++i)
   {
      // Change ctrl30.png to ctrl20.png, etc. This is a hack. The alternative is to 
      // make a new GUI_NAME for this to send up from server side. 
      var sSmallIcon = g_controllers[i].getAttribute(GUI_NAME_ICON_SMALL);
      sSmallIcon = sSmallIcon.slice(0,sSmallIcon.length-6) + "20.png"; 
      
      g_dropDown.AddChild(sSmallIcon, g_controllers[i].getAttribute(GUI_NAME_LABEL), g_controllers[i].getAttribute(ATTR_NAME_UNIQUE_ID));
   }
   
   if(!g_controllers.length)
   {
      g_dropDown.InitialDisplay(g_sp.LS(STR_MSG_NO_CTRLS_DETECTED_SHORT), "images/degraded20.png");
   }

   g_dropDown.ForceSelectionNotice();      
   
   // Rescan button is global because some people need to hide/restore it and therefore have access. 
   oCtrlDropDown.innerHTML = "<div style='float:left;'>" + g_dropDown.drawDropDown() + "</div>" + "<a style='margin-left:10px;' href=# onclick=Rescan();>" + filterIcon('images/rescan25.png', '25px', '25px') + "<span style='margin-left:2px;'>" + g_sp.LS(STR_RESCAN) + "</span></a>";

   g_DocumentHKManager = new CHotKeyManager(DOCUMENT_ID);
   // H opens the help popup.
   g_DocumentHKManager.SetCallbackHotKey(72, "ShowHelp");
   // F5 rescans.
   g_DocumentHKManager.SetCallbackHotKey(116, "Rescan");
   g_AppAreaHKManager = new CHotKeyManager("GeneralApplicationAreaID");

   g_statusView = new CStatusViewWB("STATUS_AREA_ID");
   g_statusView.show();

   g_treeView   = new CTreeViewWB(g_model, "TREE_VIEW_ID");
   g_treeView.show();

   g_tabManager = new CTabDlg("TAB_AREA_ID", g_sp.LS(STR_CONFIGURE));
   // Add hotkeys
   // V - Toggle between physical and logical view
   g_DocumentHKManager.SetCallbackHotKey(86, "togglePhysicalLogicalView", g_treeView);
   // F - Refresh Controller
   g_DocumentHKManager.SetCallbackHotKey(70, "refreshController", g_treeView);
   // W - Configuration Wizards
   g_DocumentHKManager.SetCallbackHotKey(87, "g_tabManager.ShowWhiteboard", null, "\"" + g_sp.LS(STR_WIZARDS) + "\"");
   // X - Exit Application
   g_DocumentHKManager.SetCallbackHotKey(88, "CloseApp", null, "\"hotkey\"");

   <!.IfNotDefined=NDEBUG>
   // JTT Debug - begin
   // O - Show all cookie data
   g_DocumentHKManager.SetCallbackHotKey(79, "DebugShowAllData", new CUserPreferences());
   //JTT Debug - end
   <!.EndIf>

   g_tabManager.AddTab(g_sp.LS(STR_CONFIGURE), new CConfigWB(g_model, "CONFIG_APP_AREA_ID"), 'configure');

   // Add SSP Tab if controller supporting SSP exists
   if (g_hasSSPControllers)
   {
      g_tabManager.AddTab(g_sp.LS(STR_SSP), new CSSPWB(g_model, "SSP_APP_AREA_ID"), 'ssp');
   }
   else
   {
      var el = document.getElementById("ssp");
      el.parentNode.removeChild(el);
   }
   var bAddDiagnosticsTab = false;
   // Wizards don't degrade well when there are no controllers detected, so just remove the tab completely.
   // Only show the Configuration tab if no controllers are detected.
   if (g_dropDown.getNumberofChildren() > 0)
   {
      g_tabManager.AddTab(g_sp.LS(STR_WIZARDS),   new CWizardWB(g_model, "WIZARDS_APP_AREA_ID"), 'wizards');
      bAddDiagnosticsTab = true;
   }
   else
   {
      var el = document.getElementById("wizards");
      el.parentNode.removeChild(el);
      if(g_nonSAControllers.length > 0)
      {
         bAddDiagnosticsTab = true;
      }
      else
      {
            el = document.getElementById("diagnose");
            el.parentNode.removeChild(el);
      }
   }
   if(bAddDiagnosticsTab)
   {
      g_tabManager.AddTab(g_sp.LS(STR_DIAGNOSE),  new CDiagnoseWB(g_model, "DIAGS_APP_AREA_ID"), 'diagnose');
   }

   // If we are using mockup data, we give them the option of what tab to start on
   if(g_model.deviceRoot().getAttribute(GUI_NAME_DEFAULT_TAB))
   {
      var g_tmpStr= "test";
      eval("g_tmpStr = " + g_model.deviceRoot().getAttribute(GUI_NAME_DEFAULT_TAB) + ";");
      g_tabManager.SetDefaultWhiteboard(g_tmpStr);
   }     

   g_lockView = new CLockViewWB("LOCK_APP_AREA_ID");
   g_tabManager.AddTab("lock",  g_lockView, 'lock');
   
   g_failView = new CFailViewWB("FAIL_APP_AREA_ID");
   g_tabManager.AddTab("fail",  g_failView, 'fail');
   

   document.getElementById("GeneralApplicationAreaID").style.display = "block";

   var sPreferences = new CUserPreferences();
   var sUserPreferredView = sPreferences.GetValue("CONFIG_VIEW");
   if (sUserPreferredView)
   {
      ConfigureViewStorageClick(sUserPreferredView);
   }
   g_tabManager.ShowDefaultWhiteboard();
}
CResizeCtrl.spot2();

function showCurrentSelectedController(sHighlightMode)
{
   // Turn off the last selected controller's LED's
   var sCtrlID = g_dropDown.getLastSelectedValue();
   if ((sCtrlID != "") && (g_lockState == "OK"))
   {
      g_blinkManager.BlinkAsync(sCtrlID, true); // Turn off all the LED's
   }
   // Get the currently selected controller unique id
   g_deviceView.ShowController(g_dropDown.getCurrentSelectedValue(), sHighlightMode);
}

function CloseApp(caller)
{
   var exit = true;  // proceed with exit
   var session = new CSessionData();

   if (session.GetData("task_state", "task_in_progress"))
   {
      if (exit = confirm(g_sp.LS(STR_MSG_EXIT_IN_TASK)))
      {
         session.SetData("task_state", "task_in_progress", false);
      }
   }
   else if (session.GetData("wizard_state", "wizard_in_progress"))
   {
      if (exit = confirm(g_sp.LS(STR_MSG_EXIT_IN_WIZARD)))
      {
         session.SetData("wizard_state", "wizard_in_progress", false);
      }
   }
   else if ((typeof (caller) != "undefined") && (caller == "hotkey"))  
   {
         <!.IfNotDefined=ISShowReboot>
      exit = confirm(g_sp.LS(STR_WARNING_EXIT));
         <!.EndIf>
   } 
   <!.IfDefined=ISShowReboot>
   if (exit)
   {
         exit = confirm(g_sp.LS(STR_WARNING_EXIT_REBOOT));
   }
   <!.EndIf>
   if (exit)
   {
      if (g_isOfflineEnvironment)
      {      
         // Turn off all the LED's
         g_blinkManager.BlinkAsync(g_dropDown.getCurrentSelectedValue(), true);
      }
      if(g_isMoz)
      {
         // This next line is a Firefox hack. Without it, Firefox will not 
         // close the window because it does not allow windows that were
         // not created with script to be closed by script.
         parent.window.open('','_parent','');
      }
      else
      {
        if(msieversion() >= 6)
        {
         parent.window.opener='Self';
         parent.window.open('','_parent','');
        }
      }
      parent.window.close();
   }
};

function ShowHelp()
{
   var currentTab = (new CUserPreferences()).GetValue("TAB_ID", "");
   var taskHelpOpName = document.getElementById(currentTab+"taskHelpOpName");
   var taskHelpOpNameValue = '';
   if(taskHelpOpName != null){
      taskHelpOpNameValue = taskHelpOpName.value;
   }
   var sHeader = g_sp.LS(HELP_ACU_HELP);
   var printBtn = filterIcon('images/printer30.png', '30px', '30px', 'iconFilter'); 
   var nHelpContentHeight = 450;
   if(g_isOnOfflineSmartStart)
   {
      nHelpContentHeight -= 50;
   }
   var sContent = '<div id="helpCenter"><div id="helpAll">';
   sContent += '<div id="helpTab">'+g_sp.LS(STR_CONTENTS)+'</div>';
   sContent += '<div id="helpPrint"><div id="helpPrintButton">';
   if (g_isOfflineEnvironment == false) 
   {
      sContent += '<a href=# onclick=printContents();>'+printBtn+g_sp.LS(STR_PRINT)+'</a>';
   } 
   sContent += '</div></div><div id="helpExpander"><div id="helpExpanderTable">';
   sContent += '<table cellpadding="0" cellspacing="0" width="100%"><tr><td height="30">';
   sContent += '<div class="buttonSet buttonsAreLeftAligned" style="height:15px;margin-top:0px;margin-bottom:0px;margin-left:0px;">';
   sContent += '<div class="bWrapperUp"><div>';
   sContent += '<button class="hpButtonVerySmall" onClick="showAll();"><img src="images/plus-plus.gif"></button>';
   sContent += '</div></div>';
   sContent += '<div class="bWrapperUp"><div>';
   sContent += '<button class="hpButtonVerySmall" onClick="hideAll();"><img src="images/minus-minus.gif"></button>';
   sContent += '</div></div>';
   sContent += '</div>'; // button set div
   sContent += '</td>'; 
   sContent += '<td><input type="text" id="helpSearchInput"/><div id="helpHistory">';// BOF button set for History
   sContent += '<div id="hBackward"><div id="historyBackwardOff">' + filterIcon('images/backwardoff20.png', '20px', '20px') + '</div><a id="linkNavBack" href=# onclick="onBackClick();" onMouseOver="changeBackImage();" onMouseOut="changeBackImageBack();"><div id="historyBackwardOn"></div><div id="historyBackward"></div></a></div>';
   sContent += '<div id="hForward"><div id="historyForwardOff">' + filterIcon('images/forwardoff20.png', '20px', '20px') + '</div><a id="linkNavForw" href=# onclick="onForwardClick();" onMouseOver="changeForwImage();" onMouseOut="changeForwImageBack();"><div id="historyForwardOn""></div><div id="historyForward"></div></a></div>';
   sContent += '</div></td></tr></table>'; // EOF button set for History
   sContent += '</div></div>'; //expander div
   sContent += '<input type="hidden" id="taskHelpOpName" name="taskHelpOpName" value="'+taskHelpOpNameValue+'" /><input type="hidden" id="currentTab" name="currentTab" value="'+currentTab+'" /><input type="hidden" id="selectedHelpFolder" name="selectdHelpFolder" value="" />';
   sContent += '<div id="helpContainer">';
   sContent += '<table><tr>';
   sContent += '<td width="285px">';
   sContent += '<div id="helpTree"><div id="helpTreePadding">';
   sContent += '<ul id="helpTreeRoot"></ul>';
   sContent += '</div></div>';
   sContent += '</td>';
   sContent += '<td><div id="helpContent" style="height:' + nHelpContentHeight + 'px;"></div></td>';
   sContent += '</tr></table>';
   sContent += '</div>'; // close helpContainer
   sContent += '</div></div>'; // close helpAll, helpCenter
   
   var popup = new CPrintFriendlyPopup(false, g_sp.LS(STR_ACU_HELP), sContent);
   popup.showPrintFriendlyPopup(sHeader);
}
controllerList();
</script>
<span id="menuContainer"></span>
<script language="JavaScript" type="text/javascript">
reconcileEventHandlers();
new CSplitterBar("SPLITTER_CONTAINER", "SPLITTER_BAR", CResizeCtrl.setMiddleUnitWidthValue, CResizeCtrl.sideMargin, CResizeCtrl.configMiddleLeftWidthMin, CResizeCtrl.configMiddleRightWidthMin);
</script>
</body>
</html>
